Subject: NNCP Services

From: Koushik Roy <[email-masked]>
Date: Fri, 08 Oct 2021 17:48:54 -0700

Hey,

I've been playing around with NNCP and really love what I'm finding so
far. I've built a whole bunch of stuff on NNCP so far, including
a youtube-dl based video downloader and a Telegram bot that lets me
send/receive messages through NNCP. (The latter bot was something I
cooked up for use on a trip where I was going to have low connectivity
and it worked really well.) I also use NNCP as a way to access services
and commands on my LAN at home, which I expose through a relay node with
an external static IPv4 IP. I was wondering if others had built any
services on NNCP and if so what other folks been doing and what patterns
they've been using?

So far I've settled on a pattern of having `nncp-exec` commands actually
push a new line onto a FIFO. I have a daemon that reads from this FIFO
and uses it to actually perform work. This seems to not incur any
head-of-line blocking with NNCP. In the case of my youtube-dl downloader
this makes sense as a large media file may actually be a very large
download and take a while to finish. I plan on playing around with email next.

I've also encountered a few crashes which I noted down in a file I saved
in /tmp ... and yeah now I don't have it anymore. I'll see if I can
capture those crashes again so I can post this on the list. Anyway
that's all and sorry for getting a bit stream-of-consciousness.

Thanks,
Koushik